#ifndef __PDFFUNCTIONS_H__
#define __PDFFUNCTIONS_H__

#include <windows.h>

#import "..\\..\\bin\\pdfshell.exe"

int __stdcall VeryInitializeLibrary();
void __stdcall VeryUninitializeLibrary();

long __stdcall VeryCreate(char *filename);
long __stdcall VeryOpen(char *filename);
long __stdcall VeryAddImage(long id,char *filename);
int __stdcall VerySplitMergePDF(char *lpCommandLine);
long __stdcall VeryStampLayerOpen(char *In,char *Out,char *lpFGLayerName,char *lpBGLayerName);
void __stdcall VeryClose(long id);
long __stdcall VerySetFunction(long id,long code,long para1,long para2,char *para3,char *para4);
long __stdcall VeryGetFunction(long id,long code,long para1,long para2,char *para3,char *para4);
long __stdcall VeryStampOpen(char *In,char *Out);
void __stdcall VeryStampClose(long id);
long __stdcall VeryStampGetFunction(long id,long code,long para1,long para2,char *para3,char *para4);
long __stdcall VeryStampSetFunction(long id,long code,long para1,long para2,char *para3,char *para4);
long __stdcall VeryStampAddImage(long id,long position, char *filename,
							long shift_lr,long shift_tb,long rotate,long layer,
							long zoomW,long zoomH,
							long action,char *link,long pageno);
long __stdcall VeryStampAddImageEx(long id,long position, char *filename,
							long shift_lr,long shift_tb,long rotate,long layer,
							long width,long height,
							long action,char *link,long pageno);
long __stdcall VeryStampAddText( long id,long position, 
				char *stringA,long color,long alignment,
				long shift_lr,long shift_tb,long rotate,long layer,long hollow,
				long fontcode,char *fontname,long fontsize,
				long action,char *link,long pageno);
long __stdcall VeryStampAddLine(long id,long position, long width,long color,
							long shift_lr,long shift_tb,long rotate,long layer,
							long zoomW,long zoomH);
long __stdcall VeryStampAddRect(long id,long sx,long sy,long ex,long ey, long side_width,long side_color, long flagFill,long fill_color);
int __stdcall VeryRepairPDF(char *input, char *output);
long __stdcall VeryStampAddLineEx(long id,long sx,long sy,long ex,long ey,long width,long color);
int __stdcall VeryGetPDFFileMediaBox(const char *input, int pagenum,float *left,float *top, float *right, float *bottom);
long __stdcall ImageStampOpen(char *In,char *Out);
void __stdcall ImageStampClose(long id);
long __stdcall ImageStampAddText( long id, int x, int y, char *text,long color,struct pdfshell2::LOGFONT font,int style);
long __stdcall ImageStampAddImage(long id,int x,int y, int width, int height,char *filename,
		BOOL bTransparent);
long __stdcall ImageStampGetInfo(long id,struct pdfshell2::BITMAPINFOHEADER *lpbi);
long __stdcall ImageStampPrint(long id, const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies);
long __stdcall ImageStampSetPageRange(long id, char *lpPageRange);
void __stdcall ImageStampCloseAndNotSave(long id);
long __stdcall ImageStampShow(long id, HDC hDC,struct pdfshell2::RECT *rcDst, struct pdfshell2::RECT *rcSrc);
long __stdcall ImageStampGetDIBLength(long id);
long __stdcall ImageStampGetDIB(long id, VARIANT *lpDIBData);
void __stdcall ImageStampSetLibDirectoryName(const char *ptrLibDirectory);
long __stdcall ImageStampAddLine( long id, int x0, int y0, int x1, int y1, 
				 int width,long color,int style);
HDC __stdcall ImageStampGetHDC( long id);
long __stdcall ImageStampReleaseHDC( long id, HDC hDC);
long __stdcall VeryShellPrintPDFFileTimeOut(DWORD dwMilliseconds);
long __stdcall VeryShellPrintPDFFileMargins(long lMargins);
long __stdcall ImageStampAddText_VB( long id, int x, int y, char *text,long color,int style,
	int nPointSize,int nOrientation,char* lpszFaceName);
long __stdcall ImageStampPrintEx(long id, const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies,
								 int bShellPrint);
int __stdcall VeryPrintPDFFile(const char *lpPDFFileName,const char *ptrPrintName,
							   long dmOrientation, long dmPaperSize,long dmCopies);
int __stdcall VeryRunCommand(char *szCommand, long para1,long para2,char *para3,char *para4);
long __stdcall VeryShellPrintPDFFileEx(const char *lpPDFFileName,const char *ptrPrintName,
						  long dmOrientation, long dmPaperSize,long dmCopies,int bShellPrint);
long __stdcall VeryShellPrintPDFFile(const char *lpPDFFileName,const char *ptrPrintName,
						  long dmOrientation, long dmPaperSize,long dmCopies);
long __stdcall VeryAddInfo (long id, char * Title, char * Subject,char * Author,char * Keywords,char * Creator);
long __stdcall VeryAddInfoEx (long id, char *key, char *value, int iLen);
long __stdcall VeryStampAddRectWithLayer(long id,long sx,long sy,long ex,long ey, long side_width,
				    long side_color, long flagFill,long fill_color,long layer);
long __stdcall VeryStampReg(char *reg);
long __stdcall VeryStampUndo(char *filename);
int __stdcall VeryGetPDFFileInfo(const char *input, char *output);
int __stdcall VeryGetPDFFileInfoEx(const char *input, char* sTitle, char* sSubject, 
								   char* sAuthor, char* sKeywords, char* sCreator,
								   char* sProducer, char* sVersion, char* sPageCount,
								   char* sCreatedDate, char* sModifyDate);
long __stdcall VeryAddTextEx(long id,long x,long y, char *stringA,long color);
long __stdcall VeryAddText(long id,long x,long y,long width,long height, char *stringA,long color,long bkcolor,long lFormat);
long __stdcall VeryAddTxt(long id,char *filename,long color,
			long PageWidth,long PageHeight,long AutoNewLine,long AutoWidthAdjust,
			long LeftMargin,long RightMargin,long TopMargin,long BottomMargin,
			long TabSize);
long __stdcall VeryAddLine(long id,long sx,long sy,long ex,long ey,long width,long color);
long __stdcall VeryAddRect(long id,long sx,long sy,long ex,long ey,
			long side_width,long side_color,
			long flagFill,long fill_color);
long __stdcall VeryAddCircle(long id,long x,long y, long radius,
			long side_width,long side_color,
			long flagFill,long fill_color);
long __stdcall VeryAddEllipse(long id,long sx_,long sy_,long ex_,long ey_,
			long side_width,long side_color,
			long flagFill,long fill_color);
long __stdcall VeryAddPolygon(long id,struct pdfshell2::POINT * lpPoints, int nCount,
			long side_width,long side_color,
			long flagFill,long fill_color);
long __stdcall VeryAddCurveTo(long id,long sx_,long sy_,long x1,long y1,
			long x2,long y2,long x3,long y3,
			long side_width,long side_color);

long __stdcall VeryAddImageData(long id, char *lpImgData,long width,long height,long color/*1,8,24*/);
int __stdcall VeryConvertImageToPDF(char *input, char *output,char *options);
long __stdcall VeryDecryptPDF(const char * inFileName, const char *outFileName,
			   const char *OwnerPassword, const char *UserPassword);
BOOL __stdcall VeryIsPDFEncrypted(const char * inFileName);
long __stdcall VeryEncryptPDF(const char * inFileName, const char *outFileName, 
			   long EnctyptLen, long permission, 
			   const char *OwnerPassword, const char *UserPassword);
BOOL __stdcall VeryTestEncryptedPDF(const char * inFileName,const char *OwnerPassword, 
				 const char *UserPassword);
int __stdcall VeryAppendPDF(char *ptrExistingPDFName,char *ptrAppendPDF);
int __stdcall VerySplitMergePDFEx(char *lpInputPDF,char *lpPageRange,char *lpOutPDF);
int __stdcall VeryMergePDFFiles(LPSTR lpMergePDFFiles, LPCTSTR lpOutPDF);
int __stdcall VeryGetPDFFilePageCount(const char *lpInputPDF);
int __stdcall VeryGetPDFFilePageCount2(const char *lpInputPDF);
int __stdcall VeryGetPDFFilePageCountFast(const char *lpInputPDF);

int __stdcall TIFFImageGetPageCount(char *inputTIFFFile);
int __stdcall TIFFImageGetColors(char *inputTIFFFile, int pageno);
int __stdcall TIFFImageGetCompression(char *inputTIFFFile, int pageno);
int __stdcall TIFFImageSetOptions(char *inputTIFFFile, int pageno, int colors, int compression);


#endif